// spica javascript libraries - hash.js
// == written by Takuya Otani <takuya.otani@gmail.com> ===
// == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

// ver 0.00 [2008/11/01] the first attempt

Spica.Hash = function(hash)
{
	this.$ = (typeof hash == 'object') ? hash : {};
	return this;
}
Spica.Hash.prototype = {
	extend : function(source)
	{
		for (var elem in source)
			this.$[elem] = source[elem];
		return this;
	},
	keys : function()
	{
		var key = [];
		for (var elem in this.$)
			key.push(elem);
		return key;
	},
	values : function()
	{
		var val = [];
		var key = this.keys();
		for (i=0,n=key.length;i<n;i++)
			val.push(this.$[key[i]]);
		return val;
	}
};
